// PWM_print_duty_cycle.s - Implementa la rutina PWM_print_duty_cycle

// Directivas para el ensamblador
// ------------------------------
.syntax unified
.cpu cortex-m3

// Declaración de funciones externas y exportadas
// ----------------------------------------------
.global PWM_print_duty_cycle               @ Para que la función 'PWM_print_duty_cycle' sea
.type PWM_print_duty_cycle, %function      @   accesible desde otros módulos

// Declaración de constantes
// -------------------------
// Dirección base y offsets de los registros del PWM
.equ PWM_BASE,  0x40094000  @ Dirección base de E/S del PWM
.equ PWM_CDTY5, 0x2A4       @ Offset PWM Channel Duty Cycle Register (channel 5)
.equ PWM_CPRD5, 0x2AC       @ Offset PWM Channel Period Register (channel 5)


// Comienzo de la zona de datos
// ----------------------------
.data
ciclo_str: .asciz "Ciclo de trabajo... "
frac_str:  .asciz "/"


// Comienzo de la zona de código
// -----------------------------
.text

/*
   Subrutina 'PWM_print_duty_cycle'
     MUuestra informacin sobre el ciclo de trabajo.
   Parámetros de entrada:
     No tiene.
   Parámetro de salida:
     No tiene.
*/
.thumb_func
PWM_print_duty_cycle:
  push  {r4,lr}              @ Apila r4 y LR
  ldr   r4, =PWM_BASE        @ r4 <- dirección base del controlador PWM
  // Muestra texto
  ldr   r0, =ciclo_str
  bl    printString
  // Muestra PWM_CDTY (Duty cycle)
  ldr   r0, [r4, #PWM_CDTY5]
  bl    printInt
  // Muestra '/'
  ldr   r0, =frac_str
  bl    printString
  // Muestra PWM_CPRD (Period)
  ldr   r0, [r4, #PWM_CPRD5]
  bl    printInt
  // Nueva línea
  bl    printNL

  pop   {r4,pc}              @ Desapila r4 y retorna (PC <- LR)
.end

