/* Teensyduino Core Library
* http://www.pjrc.com/teensy/
* Copyright (c) 2013 PJRC.COM, LLC. */

#define MODIFIERKEY_CTRL ( 0x01 | 0x8000 )
#define MODIFIERKEY_SHIFT ( 0x02 | 0x8000 )
#define MODIFIERKEY_ALT ( 0x04 | 0x8000 )
#define MODIFIERKEY_GUI ( 0x08 | 0x8000 )
#define MODIFIERKEY_LEFT_CTRL ( 0x01 | 0x8000 )
#define MODIFIERKEY_LEFT_SHIFT ( 0x02 | 0x8000 )
#define MODIFIERKEY_LEFT_ALT ( 0x04 | 0x8000 )
#define MODIFIERKEY_LEFT_GUI ( 0x08 | 0x8000 )
#define MODIFIERKEY_RIGHT_CTRL ( 0x10 | 0x8000 )
#define MODIFIERKEY_RIGHT_SHIFT ( 0x20 | 0x8000 )
#define MODIFIERKEY_RIGHT_ALT ( 0x40 | 0x8000 )
#define MODIFIERKEY_RIGHT_GUI ( 0x80 | 0x8000 )
#define KEY_MEDIA_VOLUME_INC 0x01
#define KEY_MEDIA_VOLUME_DEC 0x02
#define KEY_MEDIA_MUTE 0x04
#define KEY_MEDIA_PLAY_PAUSE 0x08
#define KEY_MEDIA_NEXT_TRACK 0x10
#define KEY_MEDIA_PREV_TRACK 0x20
#define KEY_MEDIA_STOP 0x40
#define KEY_MEDIA_EJECT 0x80
#define KEY_A ( 4 | 0x4000 )
#define KEY_B ( 5 | 0x4000 )
#define KEY_C ( 6 | 0x4000 )
#define KEY_D ( 7 | 0x4000 )
#define KEY_E ( 8 | 0x4000 )
#define KEY_F ( 9 | 0x4000 )
#define KEY_G ( 10 | 0x4000 )
#define KEY_H ( 11 | 0x4000 )
#define KEY_I ( 12 | 0x4000 )
#define KEY_J ( 13 | 0x4000 )
#define KEY_K ( 14 | 0x4000 )
#define KEY_L ( 15 | 0x4000 )
#define KEY_M ( 16 | 0x4000 )
#define KEY_N ( 17 | 0x4000 )
#define KEY_O ( 18 | 0x4000 )
#define KEY_P ( 19 | 0x4000 )
#define KEY_Q ( 20 | 0x4000 )
#define KEY_R ( 21 | 0x4000 )
#define KEY_S ( 22 | 0x4000 )
#define KEY_T ( 23 | 0x4000 )
#define KEY_U ( 24 | 0x4000 )
#define KEY_V ( 25 | 0x4000 )
#define KEY_W ( 26 | 0x4000 )
#define KEY_X ( 27 | 0x4000 )
#define KEY_Y ( 28 | 0x4000 )
#define KEY_Z ( 29 | 0x4000 )
#define KEY_1 ( 30 | 0x4000 )
#define KEY_2 ( 31 | 0x4000 )
#define KEY_3 ( 32 | 0x4000 )
#define KEY_4 ( 33 | 0x4000 )
#define KEY_5 ( 34 | 0x4000 )
#define KEY_6 ( 35 | 0x4000 )
#define KEY_7 ( 36 | 0x4000 )
#define KEY_8 ( 37 | 0x4000 )
#define KEY_9 ( 38 | 0x4000 )
#define KEY_0 ( 39 | 0x4000 )
#define KEY_ENTER ( 40 | 0x4000 )
#define KEY_ESC ( 41 | 0x4000 )
#define KEY_BACKSPACE ( 42 | 0x4000 )
#define KEY_TAB ( 43 | 0x4000 )
#define KEY_SPACE ( 44 | 0x4000 )
#define KEY_MINUS ( 45 | 0x4000 )
#define KEY_EQUAL ( 46 | 0x4000 )
#define KEY_LEFT_BRACE ( 47 | 0x4000 )
#define KEY_RIGHT_BRACE ( 48 | 0x4000 )
#define KEY_BACKSLASH ( 49 | 0x4000 )
#define KEY_NON_US_NUM ( 50 | 0x4000 )
#define KEY_SEMICOLON ( 51 | 0x4000 )
#define KEY_QUOTE ( 52 | 0x4000 )
#define KEY_TILDE ( 53 | 0x4000 )
#define KEY_COMMA ( 54 | 0x4000 )
#define KEY_PERIOD ( 55 | 0x4000 )
#define KEY_SLASH ( 56 | 0x4000 )
#define KEY_CAPS_LOCK ( 57 | 0x4000 )
#define KEY_F1 ( 58 | 0x4000 )
#define KEY_F2 ( 59 | 0x4000 )
#define KEY_F3 ( 60 | 0x4000 )
#define KEY_F4 ( 61 | 0x4000 )
#define KEY_F5 ( 62 | 0x4000 )
#define KEY_F6 ( 63 | 0x4000 )
#define KEY_F7 ( 64 | 0x4000 )
#define KEY_F8 ( 65 | 0x4000 )
#define KEY_F9 ( 66 | 0x4000 )
#define KEY_F10 ( 67 | 0x4000 )
#define KEY_F11 ( 68 | 0x4000 )
#define KEY_F12 ( 69 | 0x4000 )
#define KEY_PRINTSCREEN ( 70 | 0x4000 )
#define KEY_SCROLL_LOCK ( 71 | 0x4000 )
#define KEY_PAUSE ( 72 | 0x4000 )
#define KEY_INSERT ( 73 | 0x4000 )
#define KEY_HOME ( 74 | 0x4000 )
#define KEY_PAGE_UP ( 75 | 0x4000 )
#define KEY_DELETE ( 76 | 0x4000 )
#define KEY_END ( 77 | 0x4000 )
#define KEY_PAGE_DOWN ( 78 | 0x4000 )
#define KEY_RIGHT ( 79 | 0x4000 )
#define KEY_LEFT ( 80 | 0x4000 )
#define KEY_DOWN ( 81 | 0x4000 )
#define KEY_UP ( 82 | 0x4000 )
#define KEY_NUM_LOCK ( 83 | 0x4000 )
#define KEYPAD_SLASH ( 84 | 0x4000 )
#define KEYPAD_ASTERIX ( 85 | 0x4000 )
#define KEYPAD_MINUS ( 86 | 0x4000 )
#define KEYPAD_PLUS ( 87 | 0x4000 )
#define KEYPAD_ENTER ( 88 | 0x4000 )
#define KEYPAD_1 ( 89 | 0x4000 )
#define KEYPAD_2 ( 90 | 0x4000 )
#define KEYPAD_3 ( 91 | 0x4000 )
#define KEYPAD_4 ( 92 | 0x4000 )
#define KEYPAD_5 ( 93 | 0x4000 )
#define KEYPAD_6 ( 94 | 0x4000 )
#define KEYPAD_7 ( 95 | 0x4000 )
#define KEYPAD_8 ( 96 | 0x4000 )
#define KEYPAD_9 ( 97 | 0x4000 )
#define KEYPAD_0 ( 98 | 0x4000 )
#define KEYPAD_PERIOD ( 99 | 0x4000 )
#define KEY_MENU  ( 101 | 0x4000 )
#define KEY_F13 ( 104 | 0x4000 )
#define KEY_F14 ( 105 | 0x4000 )
#define KEY_F15 ( 106 | 0x4000 )
#define KEY_F16 ( 107 | 0x4000 )
#define KEY_F17 ( 108 | 0x4000 )
#define KEY_F18 ( 109 | 0x4000 )
#define KEY_F19 ( 110 | 0x4000 )
#define KEY_F20 ( 111 | 0x4000 )
#define KEY_F21 ( 112 | 0x4000 )
#define KEY_F22 ( 113 | 0x4000 )
#define KEY_F23 ( 114 | 0x4000 )
#define KEY_F24 ( 115 | 0x4000 )
// for compatibility with Leonardo's slightly different names
#define KEY_UP_ARROW  KEY_UP
#define KEY_DOWN_ARROW  KEY_DOWN
#define KEY_LEFT_ARROW  KEY_LEFT
#define KEY_RIGHT_ARROW  KEY_RIGHT
#define KEY_RETURN  KEY_ENTER
#define KEY_LEFT_CTRL  MODIFIERKEY_LEFT_CTRL
#define KEY_LEFT_SHIFT  MODIFIERKEY_LEFT_SHIFT
#define KEY_LEFT_ALT  MODIFIERKEY_LEFT_ALT
#define KEY_LEFT_GUI  MODIFIERKEY_LEFT_GUI
#define KEY_RIGHT_CTRL  MODIFIERKEY_RIGHT_CTRL
#define KEY_RIGHT_SHIFT  MODIFIERKEY_RIGHT_SHIFT
#define KEY_RIGHT_ALT  MODIFIERKEY_RIGHT_ALT
#define KEY_RIGHT_GUI  MODIFIERKEY_RIGHT_GUI
// Everything below this line is not intended for use in "normal" programs.
// These private symbols populate lookup tables, which are used to translate
// ascii and UTF8 unicode into keystroke sequences.

// LAYOUT_SPANISH
#define SHIFT_MASK  0x0040
#define ALTGR_MASK  0x0080
#define DEADKEYS_MASK  0x0700
#define  CIRCUMFLEX_BITS  0x0100
#define ACUTE_ACCENT_BITS  0x0200
#define GRAVE_ACCENT_BITS  0x0300
#define TILDE_BITS  0x0400
#define DIAERESIS_BITS  0x0500
#define KEYCODE_TYPE  uint16_t
#define DEADKEY_CIRCUMFLEX  KEY_LEFT_BRACE + SHIFT_MASK
#define DEADKEY_ACUTE_ACCENT  KEY_QUOTE
#define DEADKEY_GRAVE_ACCENT  KEY_LEFT_BRACE
#define DEADKEY_TILDE  KEY_4 + ALTGR_MASK
#define DEADKEY_DIAERESIS  KEY_QUOTE + SHIFT_MASK
#define KEY_NON_US_100  63
#define ASCII_20  KEY_SPACE // 32
#define ASCII_21  KEY_1 + SHIFT_MASK // 33 !
#define ASCII_22  KEY_2 + SHIFT_MASK // 34 "
#define ASCII_23  KEY_3 + ALTGR_MASK // 35 #
#define ASCII_24  KEY_4 + SHIFT_MASK // 36 $
#define ASCII_25  KEY_5 + SHIFT_MASK // 37 %
#define ASCII_26  KEY_6 + SHIFT_MASK // 38 &
#define ASCII_27  KEY_MINUS // 39 '
#define ASCII_28  KEY_8 + SHIFT_MASK // 40 (
#define ASCII_29  KEY_9 + SHIFT_MASK // 41 )
#define ASCII_2A  KEY_RIGHT_BRACE + SHIFT_MASK // 42 *
#define ASCII_2B  KEY_RIGHT_BRACE // 43 +
#define ASCII_2C  KEY_COMMA // 44 ,
#define ASCII_2D  KEY_SLASH // 45 -
#define ASCII_2E  KEY_PERIOD // 46 .
#define ASCII_2F  KEY_7 + SHIFT_MASK // 47 /
#define ASCII_30  KEY_0 // 48 0
#define ASCII_31  KEY_1 // 49 1
#define ASCII_32  KEY_2 // 50 2
#define ASCII_33  KEY_3 // 51 3
#define ASCII_34  KEY_4 // 52 4
#define ASCII_35  KEY_5 // 53 5
#define ASCII_36  KEY_6 // 54 6
#define ASCII_37  KEY_7 // 55 7
#define ASCII_38  KEY_8 // 55 8
#define ASCII_39  KEY_9 // 57 9
#define ASCII_3A  KEY_PERIOD + SHIFT_MASK // 58 :
#define ASCII_3B  KEY_COMMA + SHIFT_MASK // 59 ;
#define ASCII_3C  KEY_NON_US_100 // 60 <
#define ASCII_3D  KEY_0 + SHIFT_MASK // 61 =
#define ASCII_3E  KEY_NON_US_100 + SHIFT_MASK // 62 >
#define ASCII_3F  KEY_MINUS + SHIFT_MASK // 63 ?
#define ASCII_40  KEY_2 + ALTGR_MASK // 64 @
#define ASCII_41  KEY_A + SHIFT_MASK // 65 A
#define ASCII_42  KEY_B + SHIFT_MASK // 66 B
#define ASCII_43  KEY_C + SHIFT_MASK // 67 C
#define ASCII_44  KEY_D + SHIFT_MASK // 68 D
#define ASCII_45  KEY_E + SHIFT_MASK // 69 E
#define ASCII_46  KEY_F + SHIFT_MASK // 70 F
#define ASCII_47  KEY_G + SHIFT_MASK // 71 G
#define ASCII_48  KEY_H + SHIFT_MASK // 72 H
#define ASCII_49  KEY_I + SHIFT_MASK // 73 I
#define ASCII_4A  KEY_J + SHIFT_MASK // 74 J
#define ASCII_4B  KEY_K + SHIFT_MASK // 75 K
#define ASCII_4C  KEY_L + SHIFT_MASK // 76 L
#define ASCII_4D  KEY_M + SHIFT_MASK // 77 M
#define ASCII_4E  KEY_N + SHIFT_MASK // 78 N
#define ASCII_4F  KEY_O + SHIFT_MASK // 79 O
#define ASCII_50  KEY_P + SHIFT_MASK // 80 P
#define ASCII_51  KEY_Q + SHIFT_MASK // 81 Q
#define ASCII_52  KEY_R + SHIFT_MASK // 82 R
#define ASCII_53  KEY_S + SHIFT_MASK // 83 S
#define ASCII_54  KEY_T + SHIFT_MASK // 84 T
#define ASCII_55  KEY_U + SHIFT_MASK // 85 U
#define ASCII_56  KEY_V + SHIFT_MASK // 86 V
#define ASCII_57  KEY_W + SHIFT_MASK // 87 W
#define ASCII_58  KEY_X + SHIFT_MASK // 88 X
#define ASCII_59  KEY_Y + SHIFT_MASK // 89 Y
#define ASCII_5A  KEY_Z + SHIFT_MASK // 90 Z
#define ASCII_5B  KEY_LEFT_BRACE + ALTGR_MASK // 91 [
#define ASCII_5C  KEY_TILDE + ALTGR_MASK // 92
#define ASCII_5D  KEY_RIGHT_BRACE + ALTGR_MASK // 93 ]
#define ASCII_5E  CIRCUMFLEX_BITS + KEY_SPACE // 94 ^
#define ASCII_5F  KEY_SLASH + SHIFT_MASK // 95 _
#define ASCII_60  GRAVE_ACCENT_BITS + KEY_SPACE // 96 `
#define ASCII_61  KEY_A // 97 a
#define ASCII_62  KEY_B // 98 b
#define ASCII_63  KEY_C // 99 c
#define ASCII_64  KEY_D // 100 d
#define ASCII_65  KEY_E // 101 e
#define ASCII_66  KEY_F // 102 f
#define ASCII_67  KEY_G // 103 g
#define ASCII_68  KEY_H // 104 h
#define ASCII_69  KEY_I // 105 i
#define ASCII_6A  KEY_J // 106 j
#define ASCII_6B  KEY_K // 107 k
#define ASCII_6C  KEY_L // 108 l
#define ASCII_6D  KEY_M // 109 m
#define ASCII_6E  KEY_N // 110 n
#define ASCII_6F  KEY_O // 111 o
#define ASCII_70  KEY_P // 112 p
#define ASCII_71  KEY_Q // 113 q
#define ASCII_72  KEY_R // 114 r
#define ASCII_73  KEY_S // 115 s
#define ASCII_74  KEY_T // 116 t
#define ASCII_75  KEY_U // 117 u
#define ASCII_76  KEY_V // 118 v
#define ASCII_77  KEY_W // 119 w
#define ASCII_78  KEY_X // 120 x
#define ASCII_79  KEY_Y // 121 y
#define ASCII_7A  KEY_Z // 122 z
#define ASCII_7B  KEY_QUOTE + ALTGR_MASK // 123 {
#define ASCII_7C  KEY_1 + ALTGR_MASK // 124 |
#define ASCII_7D  KEY_BACKSLASH + ALTGR_MASK // 125 }
#define ASCII_7E  TILDE_BITS + KEY_SPACE // 126 ~
#define ASCII_7F  KEY_BACKSPACE // 127